scala.collection.immutable

# HashSet

###
Related Docs: class HashSet | package immutable

#### object HashSet extends ImmutableSetFactory[HashSet] with Serializable

This object provides a set of operations needed to create ``immutable.HashSet`` values.

Source
  HashSet.scala

Linear Supertypes
Serializable, java.io.Serializable, ImmutableSetFactory[HashSet], SetFactory[HashSet], GenericSeqCompanion[HashSet], GenSetFactory[HashSet], GenericCompanion[HashSet], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. HashSet
2. Serializable
3. Serializable
4. ImmutableSetFactory
5. SetFactory
6. GenericSeqCompanion
7. GenSetFactory
8. GenericCompanion
9. AnyRef
10. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### type Coll = HashSet[_]

   The underlying collection type with unknown element type

   The underlying collection type with unknown element type

   Attributes
     protected[this]
   Definition Classes
     GenericCompanion

2. #### class HashSet1[A] extends LeafHashSet[A]

3. #### class HashTrieSet[A] extends HashSet[A]

   A branch node of the HashTrieSet with at least one and up to 32 children.

   A branch node of the HashTrieSet with at least one and up to 32 children.

   A

     the type of the elements contained in this hash set.

     How levels work:

     When looking up or adding elements, the part of the hashcode that is used to address the children array depends on how deep we are in the tree. This is accomplished by having a level parameter in all internal methods that starts at 0 and increases by 5 (32 = 2^5) every time we go deeper into the tree.

     hashcode (binary): 00000000000000000000000000000000 level=0 (depth=0) level=5 (depth=1) level=10 (depth=2) ^^^^^ ...

     Be careful: a non-toplevel HashTrieSet is not a self-contained set, so e.g. calling contains on it will not work! It relies on its depth in the Trie for which part of a hash to use to address the children, but this information (the level) is not stored due to storage efficiency reasons but has to be passed explicitly!

     How bitmap and elems correspond:

     A naive implementation of a HashTrieSet would always have an array of size 32 for children and leave the unused children empty (null). But that would be very wasteful regarding memory. Instead, only non-empty children are stored in elems, and the bitmap is used to encode which elem corresponds to which child bucket. The lowest 1 bit corresponds to the first element, the second-lowest to the second, etc.

     bitmap (binary): 00010000000000000000100000000000 elems: [a,b] children: ---b----------------a-----------

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### def apply[A](elems: A*): HashSet[A]

   Creates a collection with the specified elements.

   Creates a collection with the specified elements.

   A

     the type of the collection's elements

   elems

     the elements of the created collection

   returns

     a new collection with elements `elems`

   Definition Classes
     GenericCompanion

5. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

6. #### implicit def canBuildFrom[A]: CanBuildFrom[Coll, A, HashSet[A]]

   The standard `CanBuildFrom` instance for ``immutable.HashSet`` objects.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

8. #### def empty[A]: HashSet[A]

   An empty collection of type ``Set`[A]`

   An empty collection of type ``Set`[A]`

   A

     the type of the set's elements

   Definition Classes
     ImmutableSetFactory → GenericCompanion

9. #### final def eq(arg0: AnyRef): Boolean

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

   - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
   - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
   - `null.eq(null)` returns `true`.

   When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

   returns

     `true` if the argument is a reference to the receiver object; `false` otherwise.

   Definition Classes
     AnyRef

10. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

11. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

12. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

13. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

14. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

15. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

16. #### def newBuilder[A]: Builder[A, HashSet[A]]

    The default builder for ``Set`` objects.

    The default builder for ``Set`` objects.

    A

      the type of the set's elements

    Definition Classes
      ImmutableSetFactory → GenSetFactory → GenericCompanion

17. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

18. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

19. #### def setCanBuildFrom[A]: CanBuildFrom[HashSet[_], A, HashSet[A]]

    The standard `CanBuildFrom` instance for ``Set`` objects.

    The standard `CanBuildFrom` instance for ``Set`` objects.

    Definition Classes
      GenSetFactory

20. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

21. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

22. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

23. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

24. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from ImmutableSetFactory[HashSet]

### Inherited from SetFactory[HashSet]

### Inherited from GenericSeqCompanion[HashSet]

### Inherited from GenSetFactory[HashSet]

### Inherited from GenericCompanion[HashSet]

### Inherited from AnyRef

### Inherited from Any

### Ungrouped